#!/usr/sbin/dtrace -s

# pragma D option quiet

zfs_write:entry,
zfs_mkdir:return,
zfs_dirlook:return
{
       self->ts = timestamp;
}

zfs_write:return,
zfs_mkdir:return,
zfs_dirlook:return
/self->ts/
{
       printf("%s on took %d nsecs\n", probefunc,
               timestamp - self->ts);
       self->ts = 0;
}
